using System;
using System.IO;
using System.Windows.Forms;

namespace Stream
{	/// <summary>
	/// Biztonsgi msolatot kszt az aktulis projekt C# forrsllomnyairl. 
	/// </summary>
	class BiztonsgiMsolatKszt
	{	
		/// <summary>
		/// Lekrdezi a paramterknt kapott knyvtr szlknyvtrnak nevt.
		/// </summary>
		/// <param name="path">Knyvtrnv elrsi tvonallal.</param>
		/// <returns>Az utols elvlasztjel eltti tvonalrsz</returns>
		static string getParentDir(string path)
		{	//ha az tvonal elvlaszt jelben vgzdik, akkor ezt levgjuk a vgrl
			if(path[path.Length-1]==Path.DirectorySeparatorChar ||
				path[path.Length-1]==Path.AltDirectorySeparatorChar)
				path=path.Substring(0,path.Length-1);
			//Visszaadjuk az utols elvlasztjel eltti tvonalrszt.
			return Path.GetDirectoryName(path);
		}
		/// <summary>
		/// Itt kezddik az alkalmazs vgrehajtsa.
		/// </summary>
		/// <param name="args">Parancssori argumentumok</param>
		static void Main(string[] args)
		{	// A bin/Debug-ban vagyunk (ha a projekt tpusa Debug) vagy,
			// a bin/Release-ben vagyunk (ha a projekt tpusa Release) 
			// itt van az exe
			string Knyvtr=Environment.CurrentDirectory;		
			// cd ../..
			// Kt szinttel feljebb lpnk a knyvtrszerkezetben, mert ott tallhat
      // a program forrsllomnya.
			Knyvtr=getParentDir(getParentDir(Knyvtr));
			// Ellltjuk a biztonsgi knyvtr nevt tartalmaz elrsi tvonalat.
			string Biztonsgi=Path.Combine(Knyvtr,"biztonsagi");
			// Ha nincs mg ilyen nev knyvtr, akkor ltrehozzuk.
			if(!Directory.Exists(Biztonsgi))
				Directory.CreateDirectory(Biztonsgi);
			// llomnyok msolsa.
			// Sorra vesszk a knyvtrban lev sszes cs kiterjeszts llomnyt.
			foreach(FileInfo fi in (new DirectoryInfo(Knyvtr)).GetFiles("*.cs"))
			{	StreamReader sr=null;
				try
				{	
 				  //
					// Megolds fjl olvasssal s rssal
					//
          //sr = fi.OpenText();
          //FileStream fs = new FileStream(Path.Combine(Biztonsgi, fi.Name),
          //  FileMode.Create, FileAccess.Write);
          //StreamWriter sw = new StreamWriter(fs, System.Text.Encoding.UTF8);
          //sw.Write(sr.ReadToEnd());
          //sw.Close(); //bezrja a folyamot is

						//
						// Rvidtett vltozat fjl olvasssal s rssal
						//
          using (sr = fi.OpenText())
          {
            FileStream fs = new FileStream(Path.Combine(Biztonsgi, fi.Name),
              FileMode.Create, FileAccess.Write);
            using (StreamWriter sw = new StreamWriter(fs, System.Text.Encoding.UTF8))
              sw.Write(sr.ReadToEnd());
          }//megcsinlja a bezrst is

          //          //
          //          // Megolds llomnymsolssal
          //          //
          //          // Ha volt ugyanolyan nev llomny korbban, a rgit fellrjuk
          //fi.CopyTo(Path.Combine(Biztonsgi,fi.Name),true);
                }
                catch (Exception exc)
                {
                    MessageBox.Show(exc.Message);
                }
                finally
                {	// llomny lezrsa
                    if (sr != null)
                        sr.Close();
                }
			}
		}
	}
}
