using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;

namespace KonyvtarFa
{
	/// <summary>
	/// Egy TreeView komponensben megjelenti a gp meghajtit
	/// s a rajtuk lev knyvtrak szerkezett. A feltlt gomb 
  /// lenyomsakor beolvassa teljes knyvtrszerkezetet, ami 
  /// tbb percig is eltarthat!
	/// </summary>
	public class frmKnyvtrFa : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TreeView tvFa;
		private System.Windows.Forms.Button btFeltlt;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public frmKnyvtrFa()
		{	InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
      this.tvFa = new System.Windows.Forms.TreeView();
      this.btFeltlt = new System.Windows.Forms.Button();
      this.SuspendLayout();
      // 
      // tvFa
      // 
      this.tvFa.Location = new System.Drawing.Point(8, 8);
      this.tvFa.Name = "tvFa";
      this.tvFa.Size = new System.Drawing.Size(240, 248);
      this.tvFa.TabIndex = 0;
      // 
      // btFeltlt
      // 
      this.btFeltlt.Location = new System.Drawing.Point(256, 16);
      this.btFeltlt.Name = "btFeltlt";
      this.btFeltlt.Size = new System.Drawing.Size(75, 23);
      this.btFeltlt.TabIndex = 1;
      this.btFeltlt.Text = "&Feltlt";
      this.btFeltlt.Click += new System.EventHandler(this.btFeltlt_Click);
      // 
      // frmKnyvtrFa
      // 
      this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
      this.ClientSize = new System.Drawing.Size(368, 266);
      this.Controls.Add(this.btFeltlt);
      this.Controls.Add(this.tvFa);
      this.Name = "frmKnyvtrFa";
      this.Text = "Knyvtrszerkezet";
      this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// Itt kezddik az alkalmazs vgrehajtsa.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new frmKnyvtrFa());
		}
		
		/// <summary>
		/// A megadott csompont alatti knyvtrszerkezetet olvassa ki,
		/// majd behelyezi a neveket a csompont al a TreeView komponensbe.
		/// </summary>
		/// <param name="csp">Csompont</param>
		private void KnyvtrakatFeldert(TreeNode csp)
		{	// Az aktulis knyvtr kiolvassa a csompontbl.
			string AktKnyvtr=csp.FullPath;
			string []AlKnyvtrak =null;
			try
			{	// Az aktulis knyvtr alknyvtrainak lekrdezse.
			  AlKnyvtrak=Directory.GetDirectories(AktKnyvtr);
				// Minden alknyvtrat hozzadunk a komponenshez.
				foreach(string s in AlKnyvtrak)
				{	// Lekrdezzk a nevt.
					string nv=Path.GetFileName(s);
					// Mindegyikhez ltrehozunk egy j csompontot.
					TreeNode jCsp=csp.Nodes.Add(nv);
					// Rekurzvan folytatjuk.
					KnyvtrakatFeldert(jCsp);
				}
			}
			catch
			{ // Kivtel esetn nincs alknyvtr, nem csinlunk semmit
				;
			}
		}
    /// <summary>
    /// Beolvassa a teljes knyvtrszerkezetet. Tbb percig is eltarthat a futsa!
    /// </summary>
    /// <param name="sender">A feltlt gomb referencija</param>
    /// <param name="e"></param>
    private void btFeltlt_Click(object sender, EventArgs e)
    {
      //A TreeView komponens korbbi tartalmnak trlse.
      tvFa.Nodes.Clear();
      //Meghajtk lekrdezse.
      string[] Meghajtok = Directory.GetLogicalDrives();
      //Homokra kurzor megjelentse egresemnyek figyelsnek felfggesztse
      Cursor.Current = Cursors.WaitCursor;
      //Letiltja a komponens jrafestst a tartalomfeltlts befejezsig.
      tvFa.BeginUpdate();
      //A meghajtazonostkat egyenknt hozzadjuk a komponenshez.
      //Minden meghajthoz ltrehozunk egy gykrcsompontot.
      foreach (string mh in Meghajtok)
      {
        TreeNode csp = tvFa.Nodes.Add(mh);
        // Feldertjk az sszes meghajt knyvtrszerkezett
        KnyvtrakatFeldert(csp);
      }
      //Eredeti egrkurzor visszalltsa, egresemnykezels jbli elindtsa.
      Cursor.Current = Cursors.Default;
      //A komponens jrafestsnek engedlyezse.
      tvFa.EndUpdate();
    }
	}
}
